///////////////////////////////////////////////////////////////////////////////
//
//   Notify CD Player for Windows NT and Windows 95
//
//   Copyright (c) 1996-1998, Mats Ljungqvist (mlt@cyberdude.com)
//   Copyright (c) 1999-2001, Stephen Hassard (steve@notifycd.com)
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Log: cddb.h,v $
// Revision 1.2  2003/03/04 17:20:34  Ian
// Added CVS Log directive
//
// 
///////////////////////////////////////////////////////////////////////////////

#ifdef _MSC_VER
#pragma once
#endif

void CDDBInit();
void CDDBFree();

void CDDBGetDiscID(MCIDEVICEID wDeviceID,
                   DISCINFO* psDI);
BOOL CDDBQueryLocal(DISCINFO* psDI);
BOOL CDDBQueryRemote(DISCINFO* psDI,
					 BOOL bManual,
					 BOOL* pbServerError);

BOOL CDDBOpen();
void CDDBClose();
BOOL CDDBGetID(DISCINFO* psDI, char* zID);
BOOL CDDBIsEnd();
void CDDBDelete(DISCINFO* psDI);
BOOL CDDBSave(DISCINFO* psDI);

void CDDBInternetSend(MCIDEVICEID wDeviceID, 
                      DISCINFO* psDI, 
                      HWND hWnd);
BOOL CDDBInternetGet(DISCINFO* psDI, HWND hWnd);

//void CDDBGetInfo(const char* pzID, char* pzKey, char** ppzRet);
//void CDDBSetInfo(const char* pzID, char* pzKey, char* pzInfo);

BOOL CDDBQuerySites();
void FixEntry(DISCINFO* psDI);
