/*
 (C) 1.7.2003 - 22.10.2003  Petr Latovika
*/
#include <windows.h>
#include <wininet.h>
#include <shlobj.h>
#include <tlhelp32.h>

#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

//je poteba pilinkovat winmm.lib

/*
//---------------------------------------------------------------------------
USERC("hotkeyp.rc");
//---------------------------------------------------------------------------
*/
#define sizeA(a) (sizeof(a)/sizeof(*a))
#define endA(a) (a+(sizeof(a)/sizeof(*a)))

struct HotKey {
 char *note;      //text, kter se vypisuje do hlavnho okna
 char *exe;       //spustiteln soubor vetn cesty
 char *args;      //pkazov dka bez nzvu programu
 char *dir;       //pracovn adres
 UINT modifiers;  //ctrl,shift,alt,win
 UINT vkey;       //virtuln kd klvesy
 DWORD scanCode;  //scan kd klvesy
 int cmdShow;     //0=normal,1=maximized,2=minimized
 int priority;    //0=idle,1=normal,2=high,3=realtime
 int multInst;    //1=lze spustit vcekrt
 int cmd;         //intern pkaz, pokud exe=0
};

struct DiskInfo {
 int bar;
 char text[14];
 char letter[2];
} disks[26];

const DWORD priorCnst[]={IDLE_PRIORITY_CLASS,NORMAL_PRIORITY_CLASS,
  HIGH_PRIORITY_CLASS,REALTIME_PRIORITY_CLASS};
const char *priorTab[][4]={
 {"IDLE","NORMAL","HIGH","REALTIME"},
 {"nzk","normln","vysok","v relnm ase"}};
const WORD showCnst[]={
 SW_SHOWNORMAL,SW_SHOWMAXIMIZED,
 SW_SHOWMINIMIZED};
const char *showTab[][3]={
 {"normal","maximized","minimized"},
 {"normln","maximalizovan","minimalizovan"}};
const char *cmdTab[][26]={
  {
  "Shutdown","Reboot","Logoff","Suspend",
  "Screen saver","Monitor power off","Desktop resolution",
  "Always on top","Maximize window","Minimize window","Close window",
  "Hide window","Terminate process","Process priority",
  "Master volume +","Master volume -","Wave volume +","Wave volume -","Mute",
  "Eject CD","Close CD","Control panel",
  "Change wallpaper","Disk free space",
  "Empty recycle bin","Send window command"
  },{
  "Vypnout pota","Restartovat","Odhlsit uivatele","sporn reim",
  "Spoi obrazovky","Vypnout monitor","Rozlien monitoru",
  "Okno vdy navrchu","Maximalizovat","Minimalizovat","Zavt okno",
  "Skrt okno","Zabt proces","Priorita procesu",
  "Hlasitost +","Hlasitost -","Hlasitost Wave +","Hlasitost Wave -","Ztlumit zvuk",
  "Vysunout CD","Zasunout CD","Ovldac panely",
  "Zmnit tapetu","Voln msto na disku",
  "Vysypat ko","Pkaz jinmu oknu",
  },
};
const int cmdOrder2[]={ //pevod cmdTab na hk->cmd
  2,3,5,4,
  6,19,18,
  10,7,8,9,
  25,11,20,
  13,14,15,16,17,
  0,1,12,
  23,24,
  22,21
};
#ifdef __BORLANDC__
  #if sizeA(cmdOrder2)!=sizeA(cmdTab[0])
   #error Chybn dlka pole cmdOrder2
  #endif
#endif
int cmdOrder[sizeA(cmdOrder2)]; //pevod hk->cmd na index do cmdTab

const int Nlang=2, version=1;
const char *magic="hotKeys"; //hlavika souboru
const COLORREF colors[]= {
  0x90f0a0,0xffc0c0,0xf5f5f5,0xe8d2c7,0xf5fafa};
enum{ clVolMaster, clVolWave, clVolBkgnd, clDiskFree, clDskBkgnd };
const int senz=15;

char iniFile[MAX_PATH];//soubor
char exeBuf[MAX_PATH]; //pomocn buffer
char *title="Hotkeys"; //titulek okna
HotKey *hotKeyA;       //tabulka klvesovch zkratek

bool
 modif,      //provedena zmna a je teba uloit soubor
 delreg,     //zakzn uloen konfigurace po skonen programu
 monitorOff;

int
 dlgW=397,dlgH=226, //rozmry hlavnho okna
 dlgX=100,dlgY=100, //poloha hlavnho okna
 volW=130,          //velikost popup okna hlasitosti
 textY[2],volH,
 diskfreeW=180,
 diskfreeH=100,
 volDelay=2400,     //doba zobrazen hlasitosti
 diskFreeDelay=6000,//doba zobrazen volnho msta na disku
 freePrec=1,        //poet desetinnch mst pro zobrazen volnho msta
 lang=-1,           //1=anglitina, 2=etina, -1=autodetekce
 cntStart=0,        //poet sputn programu
 fontH,
 Ndisks,            //poet harddisk
 curVolume[2],      //hlasitost ve chvli zmny
 numKeys;           //poet klvesovch zkratek

unsigned seed;

static unsigned maxWallpaper;
static HotKey dlgKey;
static HWND found;
static POINT mousePos;
static int show,oldW,oldH, dlgX0,dlgY0;

HWND hWin,hDlg,listBox,hWndVolume,hWndDiskFree,hiddenWin;
HINSTANCE inst;
WNDPROC editWndProc;
HACCEL haccel;
LOGFONT font;
HFONT hFont;
HBRUSH brVolBk,brDskBk;


typedef BOOL (__stdcall *TdiskFreeFunc)(LPCTSTR,ULARGE_INTEGER*,ULARGE_INTEGER*,ULARGE_INTEGER*);
TdiskFreeFunc pGetDiskFreeSpaceEx;

const char *subkey="Software\\Petr Lastovicka\\hotkey";
const char *runkey="Software\\Microsoft\\Windows\\CurrentVersion\\Run";
const char *runName="HotkeyP";
struct Treg { char *s; int *i; } regVal[]={
 {"height",&dlgH},
 {"width",&dlgW},
 {"X",&dlgX},
 {"Y",&dlgY},
 {"lang",&lang},
 {"countStart",&cntStart},
 {"volumeDelay",&volDelay},
 {"diskFreeDelay",&diskFreeDelay},
 {"diskFreePrecision",&freePrec},
 {"diskFreeWidth",&diskfreeW}
};
struct Tregs { char *s; char *i; } regValS[]={
 {"file",iniFile}
};

OPENFILENAME ofn={
 sizeof(OPENFILENAME),0, 0,0,0,0,1,
 iniFile, sizeof(iniFile),
 0,0,0, 0, 0,0,0, "HTK", 0,0,0
};
OPENFILENAME exeOfn={
 sizeof(OPENFILENAME),0, 0,0,0,0,1,
 exeBuf, sizeof(exeBuf),
 0,0,0, 0, 0,0,0, "EXE", 0,0,0
};
OPENFILENAME argOfn={
 sizeof(OPENFILENAME),0, 0,0,0,0,1,
 exeBuf, sizeof(exeBuf),
 0,0,0, 0, 0,0,0, "", 0,0,0
};
//---------------------------------------------------------------------------
template <class T> inline void aminmax(T &x,int l,int h){
 if(x<l) x=l;
 if(x>h) x=h;
}

template <class T> T lng(T s1,T s2)
{
 if(lang==2) return s2;
 return s1;
}

int vmsg(char *caption, char *text, int btn, va_list v)
{
 char buf[256];
 if(!text) return IDCANCEL;
 vsprintf(buf,text,v);
 return MessageBox(hWin,buf,caption,btn);
}

int msg1(int btn, char *text, ...)
{
 va_list ap;
 va_start(ap,text);
 int result = vmsg(title,text,btn,ap);
 va_end(ap);
 return result;
}

void msg(char *text, ...)
{
 va_list ap;
 va_start(ap,text);
 vmsg(title,text,MB_OK|MB_ICONERROR,ap);
 va_end(ap);
}

//zmna polohy tlatka v dialogu
void moveX(HWND hDlg, int id, int dx)
{
 RECT rc;
 POINT pt;
 HWND hWnd;

 hWnd=GetDlgItem(hDlg,id);
 GetWindowRect(hWnd,&rc);
 pt.x=rc.left;
 pt.y=rc.top;
 ScreenToClient(hDlg,&pt);
 SetWindowPos(hWnd,0, pt.x+dx, pt.y,
   0,0,SWP_NOSIZE|SWP_NOZORDER);
}

void moveW(HWND hDlg, int id, int dx, int dy)
{
 RECT rc;
 HWND hWnd;

 hWnd=GetDlgItem(hDlg,id);
 GetWindowRect(hWnd,&rc);
 SetWindowPos(hWnd,0,0,0,
   rc.right-rc.left+dx, rc.bottom-rc.top+dy,
   SWP_NOMOVE|SWP_NOZORDER);
}

void setWindowXY(HWND hDlg, int id, int x,int y)
{
 RECT rc;
 rc.left=rc.top=0;
 rc.right=x;
 rc.bottom=y;
 MapDialogRect(hDlg,&rc);
 SetWindowPos(GetDlgItem(hDlg,id),0,
   rc.right,rc.bottom,
   0,0,SWP_NOSIZE|SWP_NOZORDER);
}

//test existence adrese
bool testDir(char *dir)
{
 if(!dir[0]) return false;
 DWORD attr= GetFileAttributes(dir);
 return attr==0xFFFFFFFF || !(attr&FILE_ATTRIBUTE_DIRECTORY);
}

//peten editanho pole z dialogu
int getText(HWND dlg, int id, char *&s)
{
 delete[] s;
 int l= (int) SendMessage(GetDlgItem(dlg,id),WM_GETTEXTLENGTH,0,0)+1;
 s = new char[l];
 return GetDlgItemText(dlg,id,s,l);
}

void cpStr(char *&dest, char *src)
{
 delete[] dest;
 dest = new char[strlen(src)+1];
 strcpy(dest, src);
}

//na fn zape pracovn adres a pid k nmu soubor e
void getExeDir(char *fn, char *e)
{
 int l=GetModuleFileName(0,fn,sizeof(fn)-12);
 while(l>=0 && fn[l]!='\\') l--;
 l++;
 strcpy(fn+l, e);
}
//---------------------------------------------------------------------------
void registerKeys()
{
 for(int i=0; i<numKeys; i++){
   RegisterHotKey(hWin, i, hotKeyA[i].modifiers, hotKeyA[i].vkey);
 }
}

void unregisterKeys()
{
 for(int i=0; i<numKeys; i++){
   UnregisterHotKey(hWin, i);
 }
}

void printKey(char *s, HotKey* hk)
{
 *s=0;
 if(hk->modifiers & MOD_CONTROL) strcat(s,"Ctrl+");
 if(hk->modifiers & MOD_SHIFT) strcat(s,"Shift+");
 if(hk->modifiers & MOD_ALT) strcat(s,"Alt+");
 if(hk->modifiers & MOD_WIN) strcat(s,"Win+");
 GetKeyNameText(hk->scanCode, strchr(s,0), 32);
}
//---------------------------------------------------------------------------
void addItem(int item)
{
 char buf[1024];

 HotKey *hk= &hotKeyA[item];
 printKey(buf, hk);
 strcat(buf,"\t");
 if(hk->note){
   if(hk->cmd>=0 && !*hk->note){
     strcat(buf,cmdTab[lang-1][cmdOrder[hk->cmd]]);
   }else{
     strcat(buf,hk->note);
   }
 }
 SendMessage(listBox, LB_INSERTSTRING, item, (LPARAM)buf);
}

//naplnn listBoxu
void initList()
{
 SendMessage(listBox, WM_SETREDRAW, FALSE, 0);
 SendMessage(listBox, LB_RESETCONTENT, 0,0);
 for(int i=0; i<numKeys; i++){
   addItem(i);
 }
 SendMessage(listBox, WM_SETREDRAW, TRUE, 0);
}
//---------------------------------------------------------------------------
//zmna jazyka: 1=anglitina, 2=etina
void setLang(int l)
{
 if(l<0){
   //autodetekce jazyka
   LANGID id= GetUserDefaultLangID();
   if(id==0x405) l=2;  //etina
 }
 aminmax(l,1,Nlang);
 lang=l;
 //zm menu
 HMENU n= LoadMenu(inst,lng("MENU_EN","MENU_CZ"));
 if(n){
  HMENU m= GetMenu(hWin);
  SetMenu(hWin,n);
  DestroyMenu(m);
  DrawMenuBar(hWin);
 }
 initList();
 title= lng("Hotkeys","Klvesov zkratky");
 SetWindowText(hWin,title);
 SetWindowText(GetDlgItem(hWin,102),lng("&Edit","&Upravit"));
 SetWindowText(GetDlgItem(hWin,103),lng("&Delete","&Odstranit"));
 SetWindowText(GetDlgItem(hWin,104),lng("&New","&Nov"));
 SetWindowText(GetDlgItem(hWin,105),lng("&Up","N&ahoru"));
 SetWindowText(GetDlgItem(hWin,106),lng("D&own","&Dol"));
 ofn.lpstrFilter=lng("Hotkeys (*.htk)\0*.htk\0All files\0*.*\0",
  "Klvesov zkratky (*.htk)\0*.htk\0Vechny soubory\0*.*\0");
 exeOfn.lpstrFilter=lng("Executable files\0*.exe;*.com;*.bat;*.scr\0All files\0*.*\0",
  "Spustiteln soubory\0*.exe;*.com;*.bat;*.scr\0Vechny soubory\0*.*\0");
 argOfn.lpstrFilter=lng("All files\0*.*\0","Vechny soubory\0*.*\0");
}
//---------------------------------------------------------------------------
char *fReadStr(FILE *f)
{
 char buf[1024];
 if(fgets(buf,sizeof(buf),f)==0){
   buf[0]='\n';
   buf[1]=0;
 }
 size_t l= strlen(buf);
 char *s= new char[l];
 l--;
 memcpy(s,buf,l);
 s[l]=0;
 return s;
}

//peten souboru
void rd(char *fn)
{
 FILE *f;
 HotKey *hk;
 int i,v;
 char buf[16];

 if(!fn || !*fn) return;
 if((f=fopen(fn,"rt"))==0){
   msg(lng("Cannot open file %s","Nelze otevt soubor %s"),fn);
 }else{
   fread(buf,strlen(magic),1,f);
   if(strncmp(buf,magic,strlen(magic))){
     msg(lng("Invalid format of %s","Chybn formt souboru %s"),fn);
   }else{
     fscanf(f,"%d ",&v);
     if(v!=version){
       msg(lng("Invalid version of %s","Chybn verze souboru %s"),fn);
     }else{
       unregisterKeys();
       fscanf(f,"%d", &numKeys);
       fgetc(f);
       aminmax(numKeys,0,999);
       delete[] hotKeyA;
       hotKeyA= new HotKey[numKeys];
       for(i=0; i<numKeys; i++){
         hk= &hotKeyA[i];
         hk->note= fReadStr(f);
         hk->exe= fReadStr(f);
         hk->args= fReadStr(f);
         hk->dir= fReadStr(f);
         fscanf(f,"%d %d %d %d %d %d %d",
           &hk->scanCode,&hk->vkey,&hk->modifiers,
           &hk->cmdShow,&hk->priority,&hk->multInst,&hk->cmd);
         fgetc(f);
         aminmax(hk->cmdShow,0,sizeA(showCnst)-1);
         aminmax(hk->priority,0,sizeA(priorCnst)-1);
         aminmax(hk->cmd,-1,sizeA(cmdTab[0])-1);
       }
       registerKeys();
       modif=false;
       initList();
     }
   }
   fclose(f);
 }
}

//uloen souboru
void wr(char *fn)
{
 FILE *f;
 HotKey *hk;
 int i;

start:
 if((f=fopen(fn,"wt"))==0){
   msg(lng("Cannot create file %s","Nelze vytvoit soubor %s"),fn);
 }else{
   fprintf(f,"%s%d %d\n", magic, version, numKeys);
   for(i=0; i<numKeys; i++){
     hk= &hotKeyA[i];
     fprintf(f,"%s\n%s\n%s\n%s\n%d %d %d %d %d %d %d\n",
       hk->note,hk->exe,hk->args,hk->dir,
       hk->scanCode,hk->vkey,hk->modifiers,
       hk->cmdShow,hk->priority,hk->multInst,hk->cmd);
   }
   if(fclose(f)){
     if( msg1(MB_ICONEXCLAMATION|MB_RETRYCANCEL,
       lng("Write error, file %s","Chyba pi zpisu do %s"), fn)
       ==IDRETRY) goto start;
   }
   modif=false;
 }
}

void open()
{
 ofn.hwndOwner= hWin;
 ofn.Flags= OFN_PATHMUSTEXIST|OFN_HIDEREADONLY;
 if(GetOpenFileName(&ofn)){
   rd(iniFile);
 }
}

void save()
{
 ofn.hwndOwner= hWin;
 ofn.Flags= OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
 if(GetSaveFileName(&ofn)){
   wr(iniFile);
 }
}
//---------------------------------------------------------------------------
//smazn konfigurace
void deleteini()
{
 HKEY key;
 DWORD i;

 delreg=true;
 if(RegDeleteKey(HKEY_CURRENT_USER, subkey)==ERROR_SUCCESS){
  if(RegOpenKey(HKEY_CURRENT_USER,
    "Software\\Petr Lastovicka",&key)==ERROR_SUCCESS){
   i=1;
   RegQueryInfoKey(key,0,0,0,&i,0,0,0,0,0,0,0);
   RegCloseKey(key);
   if(!i)
    RegDeleteKey(HKEY_CURRENT_USER, "Software\\Petr Lastovicka");
  }
 }
 if(RegOpenKey(HKEY_LOCAL_MACHINE, runkey, &key)==ERROR_SUCCESS){
   RegDeleteValue(key,runName);
   RegCloseKey(key);
 }
 if(RegOpenKey(HKEY_CURRENT_USER, runkey, &key)==ERROR_SUCCESS){
   RegDeleteValue(key,runName);
   RegCloseKey(key);
 }
}

//uloen konfigurace
void writeini()
{
 HKEY key;
 if(RegCreateKey(HKEY_CURRENT_USER, subkey, &key)!=ERROR_SUCCESS)
   msg(lng("Cannot write to Windows registry",
     "Nelze uloit nastaven do registr Windows."));
 else{
  for(Treg *u=regVal; u<endA(regVal); u++){
    RegSetValueEx(key, u->s, 0,REG_DWORD,
      (BYTE *)u->i, sizeof(int));
  }
  for(Tregs *v=regValS; v<endA(regValS); v++){
    RegSetValueEx(key, v->s, 0,REG_SZ,
      (BYTE *)v->i, (int)strlen(v->i)+1);
  }
  RegSetValueEx(key, "font", 0,REG_BINARY,
      (BYTE *)&font, sizeof(LOGFONT));
  RegCloseKey(key);
 }
}

//naten konfigurace
void readini()
{
 HKEY key;
 DWORD d;
 if(RegOpenKey(HKEY_CURRENT_USER, subkey, &key)==ERROR_SUCCESS){
  for(Treg *u=regVal; u<endA(regVal); u++){
    d=sizeof(int);
    RegQueryValueEx(key,u->s,0,0, (BYTE *)u->i, &d);
  }
  for(Tregs *v=regValS; v<endA(regValS); v++){
    d=256;
    RegQueryValueEx(key,v->s,0,0, (BYTE *)v->i, &d);
  }
  d=sizeof(LOGFONT);
  RegQueryValueEx(key,"font",0,0, (BYTE *)&font, &d);
  RegCloseKey(key);
 }
}

//uloen konfigurace a uloen databze
void saveAtExit()
{
 if(modif && numKeys){
   if(!*iniFile) save();
   else wr(iniFile);
 }
 if(!delreg) writeini();
}
//---------------------------------------------------------------------------
//zmna hlasitosti o incr procent, which:0=mixer,1=wave
void volume(int which, int incr)
{
 HMIXEROBJ hMix;
 MIXERLINE ml;
 MIXERLINECONTROLS mlc;
 MIXERCONTROL mc;
 MIXERCONTROLDETAILS mcd;
 ULONG mcu;

 if(mixerOpen((HMIXER*)&hMix,0,0,0,0)==MMSYSERR_NOERROR){
  for(int l=0; l<2; l++){
   ml.cbStruct=sizeof(MIXERLINE);
   ml.dwComponentType=l ? MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT:MIXERLINE_COMPONENTTYPE_DST_SPEAKERS;
   if(mixerGetLineInfo(hMix,&ml,MIXER_GETLINEINFOF_COMPONENTTYPE)==MMSYSERR_NOERROR){
     mlc.cbStruct=sizeof(MIXERLINECONTROLS);
     mlc.cControls=1;
     mlc.cbmxctrl=sizeof(MIXERCONTROL);
     mlc.pamxctrl=&mc;
     mlc.dwLineID=ml.dwLineID;
     mlc.dwControlType= incr ? MIXERCONTROL_CONTROLTYPE_VOLUME
       : MIXERCONTROL_CONTROLTYPE_MUTE;
     if(mixerGetLineControls(hMix,&mlc,MIXER_GETLINECONTROLSF_ONEBYTYPE)==MMSYSERR_NOERROR){
       mcd.cbStruct=sizeof(MIXERCONTROLDETAILS);
       mcd.dwControlID=mc.dwControlID;
       mcd.cChannels=1;
       mcd.cMultipleItems=0;
       mcd.cbDetails=4;
       mcd.paDetails=&mcu;
       if(mixerGetControlDetails(hMix,&mcd,MIXER_GETCONTROLDETAILSF_VALUE)==MMSYSERR_NOERROR){
         int minBound= ((LONG*)&mc.Bounds)[0];
         int maxBound= ((LONG*)&mc.Bounds)[1];
         int rng = maxBound - minBound;
         if(l==which){
           if(incr){
             if(rng<1000) incr= (incr*rng)/100;
             else incr= incr*(rng/100);
             if(incr>0 && mcu>unsigned(maxBound-incr)) mcu=maxBound;
             else if(incr<0 && mcu<unsigned(minBound-incr)) mcu=minBound;
             else mcu+=incr;
             //zobraz okno s hlasitost
             RECT rc;
             rc.left=0; rc.right=volW;
             rc.top=textY[l];
             rc.bottom=rc.top+fontH;
             InvalidateRect(hWndVolume,&rc,FALSE);
             SetWindowPos(hWndVolume,HWND_TOPMOST,
               (GetSystemMetrics(SM_CXSCREEN)-volW)/2,
               GetSystemMetrics(SM_CYSCREEN)-volH-35,
               0,0,SWP_NOSIZE);
             ShowWindow(hWndVolume,SW_SHOWNOACTIVATE);
             SetTimer(hWin,1,volDelay,0);
           }else{
             //ztlumen zvuku
             mcu= !mcu;
           }
           mixerSetControlDetails(hMix,&mcd,MIXER_SETCONTROLDETAILSF_VALUE);
         }
         if(rng<1000) curVolume[l]= (mcu*100)/rng;
         else curVolume[l]= mcu/(rng/100);
       }
     }
   }
  }
  mixerClose((HMIXER)hMix);
 }
}

//vysu nebo zasu CD, drive me bt napklad "D:"
void openCloseCD(char *drive, bool op)
{
 char d[3];
 MCI_OPEN_PARMS m;

 d[1]=':';
 d[2]=0;
 if(!drive || !*drive){
   for(d[0]='A'; d[0]<='Z'; d[0]++){
     if(GetDriveType(d)==DRIVE_CDROM) break;
   }
 }else{
   d[0]=*drive;
 }
 m.dwCallback=0;
 m.lpstrDeviceType="CDAudio";
 m.lpstrElementName=d;
 m.lpstrAlias=0;
 if(!mciSendCommand(0,MCI_OPEN,MCI_OPEN_TYPE|MCI_OPEN_ELEMENT,(WPARAM)&m)){
   mciSendCommand(m.wDeviceID, MCI_SET,
     op ? MCI_SET_DOOR_OPEN:MCI_SET_DOOR_CLOSED,0);
   mciSendCommand(m.wDeviceID,MCI_CLOSE,MCI_OPEN_TYPE|MCI_OPEN_ELEMENT,(WPARAM)&m);
 }
}

//zmna rozlien a potu barev
void resolution(char *param)
{
 DEVMODE dm;

 memset(&dm,0,sizeof(dm));
 dm.dmSize = sizeof(dm);
 if(*param){
   sscanf(param,"%d %d %d %d",
     &dm.dmPelsWidth, &dm.dmPelsHeight,
     &dm.dmBitsPerPel, &dm.dmDisplayFrequency);
   if(dm.dmPelsWidth) dm.dmFields|=DM_PELSWIDTH;
   if(dm.dmPelsHeight) dm.dmFields|=DM_PELSHEIGHT;
   if(dm.dmBitsPerPel) dm.dmFields|=DM_BITSPERPEL;
   if(dm.dmDisplayFrequency) dm.dmFields|=DM_DISPLAYFREQUENCY;
 }else{
   if(GetSystemMetrics(SM_CXSCREEN)==800){
     dm.dmPelsWidth=1024;
     dm.dmPelsHeight=768;
   }else{
     dm.dmPelsWidth=800;
     dm.dmPelsHeight=600;
   }
   dm.dmFields=DM_PELSWIDTH|DM_PELSHEIGHT;
 }
 ChangeDisplaySettings(&dm,CDS_UPDATEREGISTRY);

 ///SetWindowPos(FindWindow("Sledovn systmu",0), 0, (dm.dmPelsWidth==800)? 400:500,-14,0,0,SWP_NOZORDER|SWP_NOSIZE);
}

void search(char *dir, char *result, int recurse)
{
 HANDLE h;
 WIN32_FIND_DATA fd;
 char *s,oldDir[256],ext[4];

 GetCurrentDirectory(sizeof(oldDir), oldDir);
 SetCurrentDirectory(dir);

 h = FindFirstFile("*.*",&fd);
 if(h!=INVALID_HANDLE_VALUE){
  do{
   if(fd.dwFileAttributes==FILE_ATTRIBUTE_DIRECTORY){
     if(fd.cFileName[0]!='.' && recurse){
       search(fd.cFileName,result,recurse);
     }
   }else{
     s=strchr(fd.cFileName,0);
     while(*--s!='\\'){
       if(*s=='.'){
         ext[0]=(char)toupper(s[1]);
         ext[1]=(char)toupper(s[2]);
         ext[2]=(char)toupper(s[3]);
         if(ext[0]=='B' && ext[1]=='M' && ext[2]=='P' ||
            ext[0]=='J' && ext[1]=='P' && (ext[2]=='G' || ext[2]=='E') ||
            ext[0]=='G' && ext[1]=='I' && ext[2]=='F'){
           seed=314159*seed+2718281;
           if(seed>=maxWallpaper){
             maxWallpaper=seed;
             char *dummy;
             GetFullPathName(fd.cFileName,256,result,&dummy);
           }
         }
         break;
       }
     }
   }
  }while(FindNextFile(h,&fd));
  FindClose(h);
 }
 SetCurrentDirectory(oldDir);
}

//zmna tapety
void randomWallpaper(char *dir)
{
 char result[256];
 WCHAR resultW[256];

 seed=(unsigned)GetTickCount();
 maxWallpaper=0;
 result[0]=0;
 if(*dir){
   DWORD a = GetFileAttributes(dir);
   if(a==0xFFFFFFFF || !(a&FILE_ATTRIBUTE_DIRECTORY)){
     msg(lng("Cannot find directory %s","Nenalezen adres %s"),dir);
   }else{
     search(dir,result,1);
   }
 }else{
   char buf[256];
   if(GetWindowsDirectory(buf,sizeof(buf))){
     search(buf,result,0);
   }
 }
 if(result[0]){
   if(!SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, result, SPIF_UPDATEINIFILE|SPIF_SENDCHANGE)){
     HRESULT hr;
     IActiveDesktop *pActiveDesktop;
     hr = CoCreateInstance(CLSID_ActiveDesktop, NULL, CLSCTX_INPROC_SERVER,
       IID_IActiveDesktop, (void**)&pActiveDesktop);
     if(hr==S_OK){
       MultiByteToWideChar(CP_ACP,0,result,-1,resultW,256);
       pActiveDesktop->SetWallpaper(resultW,0);
       pActiveDesktop->ApplyChanges(AD_APPLY_ALL);
       pActiveDesktop->Release();
     }
   }
 }
}

//nastaven prva na vypnut nebo restart potae
void privilege()
{
 HANDLE token;
 TOKEN_PRIVILEGES tkp;

 saveAtExit();
 if(OpenProcessToken(GetCurrentProcess(),
    TOKEN_ADJUST_PRIVILEGES|TOKEN_QUERY, &token))
  if(LookupPrivilegeValue(0,SE_SHUTDOWN_NAME,&tkp.Privileges[0].Luid)){
    tkp.PrivilegeCount=1;
    tkp.Privileges[0].Attributes=SE_PRIVILEGE_ENABLED;
    AdjustTokenPrivileges(token, FALSE, &tkp, 0,0,0);
  }
}

void addDrive(char *root)
{
 DWORDLONG free,total;
 DiskInfo *d;

 if(pGetDiskFreeSpaceEx){
   if(!pGetDiskFreeSpaceEx(root,(ULARGE_INTEGER*)&free,(ULARGE_INTEGER*)&total,0)) return;
 }else{
   DWORD sectPerClust,bytesPerSect,freeClust,totalClust;
   if(!GetDiskFreeSpace(root,&sectPerClust,&bytesPerSect,&freeClust,&totalClust)) return;
   free= freeClust*(DWORDLONG)sectPerClust*bytesPerSect;
   total= totalClust*(DWORDLONG)sectPerClust*bytesPerSect;
 }
 d= &disks[Ndisks++];
 d->letter[0]=root[0];
 d->letter[1]=':';
 d->bar=(int)(free*1000/total);
 if(free>2000000000){
   sprintf(d->text,"%.*f GB", freePrec,(double)((long double)free/1073741824));
 }else if(free>2000000){
   sprintf(d->text,"%.*f MB", freePrec,(double)((long double)free/1048576));
 }else{
   sprintf(d->text,"%d kB", (int)(free/1024));
 }
}

void diskFree()
{
 RECT rc;
 UINT t;
 char c,root[4];

 aminmax(freePrec,0,6);
 root[1]=':';
 root[2]='\\';
 root[3]=0;
 Ndisks=0;
 for(c='A'; c<='Z'; c++){
   root[0]=c;
   t=GetDriveType(root);
   if(t==DRIVE_FIXED || t==DRIVE_REMOTE){
     addDrive(root);
   }
 }
 if(Ndisks){
   InvalidateRect(hWndDiskFree,&rc,FALSE);
   SetWindowPos(hWndDiskFree,HWND_TOPMOST,
     (GetSystemMetrics(SM_CXSCREEN)-diskfreeW)/2,
     GetSystemMetrics(SM_CYSCREEN)*2/3,
     diskfreeW,Ndisks*(fontH+5)+1,0);
   ShowWindow(hWndDiskFree,SW_SHOWNOACTIVATE);
   SetTimer(hWin,3,diskFreeDelay,0);
 }
}

HWND getWindow(char *s)
{
 if(s && *s){
   HWND w=FindWindow(0,s);
   if(!w) w=FindWindow(s,0);
   if(!w) msg(lng("Window \"%s\" not found",
     "Okno \"%s\" nenalezeno"), s);
   return w;
 }else{
   return GetForegroundWindow();
 }
}

void command(int cmd, char *param)
{
 HWND w;
 char *param2;
 int iparam= strtol(param,&param2,10);
 int vol= iparam ? iparam : 1;
 int i;
 DWORD pid;
 HANDLE h;
 BOOL ok=FALSE;

 while(param2 && *param2==' ') param2++;

 switch(cmd){
  case 0: //vysunout CD
   openCloseCD(param,true);
  break;
  case 1: //zasunout CD
   openCloseCD(param,false);
  break;
  case 2: //vypnout
   privilege();
   ExitWindowsEx(EWX_SHUTDOWN, iparam ? TRUE:FALSE);
  break;
  case 3: //restartovat
   privilege();
   ExitWindowsEx(EWX_REBOOT, iparam ? TRUE:FALSE);
  break;
  case 4: //sporn reim
   privilege();
   SetSystemPowerState(TRUE, iparam ? TRUE:FALSE);
  break;
  case 5: //odhlsit
   ExitWindowsEx(EWX_LOGOFF, iparam ? TRUE:FALSE);
  break;
  case 6: //spoi
   PostMessage(hWin, WM_SYSCOMMAND, SC_SCREENSAVE, 0);
  break;
  case 7: //maximalizovat
   w=getWindow(param);
   ShowWindow(w, IsZoomed(w) ? SW_RESTORE:SW_MAXIMIZE);
  break;
  case 8: //minimalizovat
   CloseWindow(getWindow(param));
  break;
  case 9: //zavt
   PostMessage(getWindow(param), WM_CLOSE, 0,0);
  break;
  case 10: //vdy navrchu
   w= getWindow(param);
   SetWindowPos(w,
     GetWindowLong(w,GWL_EXSTYLE)&WS_EX_TOPMOST ?
     HWND_NOTOPMOST:HWND_TOPMOST, 0,0,0,0, SWP_NOSIZE|SWP_NOMOVE);
  break;
  case 11: //zabt proces
   if(GetWindowThreadProcessId(getWindow(param),&pid)){
     if((h=OpenProcess(PROCESS_TERMINATE,0,pid))!=0){
       ok= TerminateProcess(h,(UINT)-1);
       CloseHandle(h);
     }
   }
   if(!ok) msg(lng("Can't terminate process","Nepodailo se ukonit proces"));
  break;
  case 12: //ovldac panely
  {
   char *buf= new char[strlen(param)+64];
   strcpy(buf,"rundll32.exe shell32.dll,Control_RunDLL ");
   if(!*param) param="appwiz";
   strcat(buf,param);
   strcat(buf,".cpl");
   WinExec(buf,SW_NORMAL);
   delete[] buf;
  }
  break;
  case 13:
   volume(0, vol);
  break;
  case 14:
   volume(0, -vol);
  break;
  case 15:
   volume(1, vol);
  break;
  case 16:
   volume(1, -vol);
  break;
  case 17: //ztlumit
   volume(0, 0);
  break;
  case 18: //rozlien
   resolution(param);
  break;
  case 19: //vypnut monitoru
   GetCursorPos(&mousePos);
   PostMessage(hWin,WM_SYSCOMMAND,SC_MONITORPOWER,*param ? iparam:2);
   SetTimer(hWin,2,100,0);
  break;
  case 20: //priorita procesu
   if(!*param) iparam=1;
   for(i=0; i<4; i++){
     if(!stricmp(priorTab[0][i],param)) iparam=i;
   }
   if(GetWindowThreadProcessId(getWindow(0),&pid)){
     if((h=OpenProcess(PROCESS_SET_INFORMATION,0,pid))!=0){
       aminmax(iparam,0,3);
       ok=SetPriorityClass(h,priorCnst[iparam]);
       CloseHandle(h);
     }
   }
   if(!ok) msg(lng("Can't change priority","Nepodailo se zmnit prioritu"));
  break;
  case 21:
   PostMessage(getWindow(param2),WM_COMMAND,iparam,0);
  break;
  case 22: //vysypat ko
  {
   HINSTANCE lib = LoadLibrary("shell32.dll");
   if(lib){
     typedef int (__stdcall *TemptyBin)(HWND,LPCTSTR,WORD);
	 TemptyBin emptyBin = (TemptyBin) GetProcAddress(lib, "SHEmptyRecycleBinA");
     if(emptyBin) emptyBin(hWin,"", (WORD) iparam);
     FreeLibrary(lib);
   }
  }
  break;
  case 23: //dal tapeta
   randomWallpaper(param);
  break;
  case 24: //voln msto na disku
   if(IsWindowVisible(hWndDiskFree)){
     PostMessage(hWin,WM_TIMER,3,0);
   }else{
     diskFree();
   }
  break;
  case 25: //skrt okno
   if(hiddenWin){
     ShowWindow(hiddenWin,SW_SHOW);
     SetForegroundWindow(hiddenWin);
     hiddenWin=0;
   }else{
     w=getWindow(param);
     if(!*param) hiddenWin=w;
     ShowWindow(w, IsWindowVisible(w)? SW_HIDE:SW_SHOW);
   }
  break;
 }
}
//---------------------------------------------------------------------------
//ozne cestu
char *cutPath(char *s)
{
 char *t;
 t=strchr(s,0);
 while(t>=s && *t!='\\') t--;
 t++;
 return t;
}

//najde PID procesu, kter odpovd danmu exe souboru
DWORD findProcess(char *exe)
{
 PROCESSENTRY32 pe;
 pe.dwSize = sizeof(PROCESSENTRY32);
 HANDLE h = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
 Process32First(h,&pe);
 do{
   if(!stricmp(cutPath(pe.szExeFile),cutPath(exe))){
     CloseHandle(h);
     return pe.th32ProcessID;
   }
 }while(Process32Next(h,&pe));
 CloseHandle(h);
 return 0;
}

//enumerace vech oken, aktivuje okno procesu pid
BOOL CALLBACK enumWin(HWND hWnd,LPARAM pid)
{
 unsigned long id;

 if(GetWindowThreadProcessId(hWnd,&id) && id==(DWORD)pid){
   if(IsWindowVisible(hWnd)){
     LONG exstyle=GetWindowLong(hWnd,GWL_EXSTYLE);
     if(!(exstyle & WS_EX_TOOLWINDOW) || !found){
       found=hWnd;
     }
   }
 }
 return TRUE;
}
//---------------------------------------------------------------------------
//zobrazen volnho msta na disku
LRESULT CALLBACK DiskFreeWndProc(HWND hWnd, UINT mesg, WPARAM wP, LPARAM lP)
{
 PAINTSTRUCT ps;
 HDC dc;
 RECT rc;
 HBRUSH br;
 int k,y;
 char buf[32];

 switch(mesg){
  case WM_PAINT:
   dc = BeginPaint(hWnd, &ps);
   SetBkMode(dc,TRANSPARENT);
   y=-3;
   for(k=0; k<Ndisks; k++){
     DiskInfo *d= &disks[k];
     y+=5;
     rc.top=y;
     rc.bottom=y+fontH;
     rc.left=18;
     rc.right=rc.left + ((diskfreeW-2-rc.left) * d->bar)/1000;
     br=CreateSolidBrush(colors[clDiskFree]);
     FillRect(dc,&rc,br);
     DeleteObject(br);
     rc.left=rc.right; rc.right=diskfreeW;
     FillRect(dc,&rc,brDskBk);
     sprintf(buf,"%d %%",curVolume[k]);
     SetTextAlign(dc,TA_LEFT);
     TextOut(dc,1,y,d->letter,2);
     SetTextAlign(dc,TA_CENTER);
     TextOut(dc,diskfreeW>>1,y, d->text, (int)strlen(d->text));
     if(k){
       MoveToEx(dc,0,y-3,0);
       LineTo(dc,rc.right,y-3);
     }
     y=rc.bottom;
   }
   EndPaint(hWnd, &ps);
  break;
  default:
   return DefWindowProc(hWnd, mesg, wP, lP);
 }
 return 0;
}
//---------------------------------------------------------------------------
//zobrazen hlasitosti
LRESULT CALLBACK VolumeWndProc(HWND hWnd, UINT mesg, WPARAM wP, LPARAM lP)
{
 PAINTSTRUCT ps;
 HDC dc;
 RECT rc;
 HBRUSH br;
 char buf[32];
 int k;
 const int x=15,x2=75;

 switch(mesg){
  case WM_PAINT:
   dc = BeginPaint(hWnd, &ps);
   SetBkMode(dc,TRANSPARENT);
   for(k=0; k<2; k++){
     rc.top=textY[k];
     rc.bottom=rc.top+fontH;
     rc.left=0;
     rc.right=((volW-2)*curVolume[k])/100;
     br=CreateSolidBrush(colors[k]);
     FillRect(dc,&rc,br);
     DeleteObject(br);
     rc.left=rc.right; rc.right=volW;
     FillRect(dc,&rc,brVolBk);
     sprintf(buf,"%d %%",curVolume[k]);
     TextOut(dc,x,textY[k],k ? "Wave: ":"Mixer:",6);
     TextOut(dc,x2,textY[k], buf,(int)strlen(buf));
   }
   EndPaint(hWnd, &ps);
  break;
  default:
   return DefWindowProc(hWnd, mesg, wP, lP);
 }
 return 0;
}
//---------------------------------------------------------------------------
//procedura pro AboutBox
BOOL CALLBACK DlgProc(HWND hWnd, UINT msg, WPARAM wP, LPARAM lP)
{
 switch(msg){

  case WM_INITDIALOG:
   return TRUE;

  case WM_COMMAND:
   wP=LOWORD(wP);
   switch(wP){
    case IDOK:
    case IDCANCEL:
     EndDialog(hWnd, wP);
    return TRUE;
   }
  break;
 }
 return 0;
}
//---------------------------------------------------------------------------
//window procedura pro hotkey edit control
LRESULT CALLBACK hotKeyClassProc(HWND hWnd, UINT mesg, WPARAM wP, LPARAM lP)
{
 char buf[64];

 switch(mesg){
  case WM_KEYDOWN:
  case WM_SYSKEYDOWN:
   if(wP!=VK_CONTROL && wP!=VK_SHIFT && wP!=VK_MENU && wP!=VK_RWIN && wP!=VK_LWIN){
     //vpis stisknut klvesy do editanho pole
     dlgKey.vkey=(UINT)wP;
     dlgKey.scanCode=(DWORD)lP;
     printKey(buf, &dlgKey);
     SetWindowText(hWnd,buf);
     //zakrtnut pepna ctrl,shift,alt,win
     CheckDlgButton(hDlg,106, GetKeyState(VK_CONTROL)<0 ? BST_CHECKED:BST_UNCHECKED);
     CheckDlgButton(hDlg,107, GetKeyState(VK_SHIFT)<0 ? BST_CHECKED:BST_UNCHECKED);
     CheckDlgButton(hDlg,108, GetKeyState(VK_MENU)<0 ? BST_CHECKED:BST_UNCHECKED);
     CheckDlgButton(hDlg,109, GetKeyState(VK_LWIN)<0 || GetKeyState(VK_RWIN)<0
       ? BST_CHECKED:BST_UNCHECKED);
     return 0;
   }
  break;
  case WM_CHAR:
   return 0; //nevype se znak do editanho pole
 }
 return CallWindowProc((WNDPROC)editWndProc, hWnd, mesg, wP, lP);
}
//---------------------------------------------------------------------------
//dialogov procedura
BOOL CALLBACK hotkeyProc(HWND hWnd, UINT mesg, WPARAM wP, LPARAM lP)
{
 HotKey *hk;
 char buf[64];
 const char **u;
 HWND combo;
 char *filePart;

 switch(mesg){
  case WM_INITDIALOG:
   hDlg=hWnd;
   SetWindowLong(hWnd, GWL_USERDATA, (LONG)lP);
   hk= &hotKeyA[lP];
   combo= GetDlgItem(hWnd,101);
   for(u=cmdTab[lang-1]; u<endA(cmdTab[lang-1]); u++){
     SendMessage(combo,CB_ADDSTRING,0,(LPARAM)*u);
   }
   SetDlgItemText(hWnd,101, hk->exe);
   if(hk->cmd>=0) SendMessage(combo,CB_SETCURSEL,cmdOrder[hk->cmd],0);
   SetDlgItemText(hWnd,102, hk->args);
   SetDlgItemText(hWnd,110, hk->dir);
   SetDlgItemText(hWnd,112, hk->note);
   CheckDlgButton(hWnd,113, hk->multInst ? BST_CHECKED:BST_UNCHECKED);
   dlgKey.scanCode=hk->scanCode;
   dlgKey.vkey=hk->vkey;
   printKey(buf,&dlgKey);
   SetDlgItemText(hWnd,103, buf);
   CheckDlgButton(hWnd,106, hk->modifiers&MOD_CONTROL ? BST_CHECKED:BST_UNCHECKED);
   CheckDlgButton(hWnd,107, hk->modifiers&MOD_SHIFT ? BST_CHECKED:BST_UNCHECKED);
   CheckDlgButton(hWnd,108, hk->modifiers&MOD_ALT ? BST_CHECKED:BST_UNCHECKED);
   CheckDlgButton(hWnd,109, hk->modifiers&MOD_WIN ? BST_CHECKED:BST_UNCHECKED);

   combo= GetDlgItem(hWnd,105);
   for(u=priorTab[lang-1]; u<endA(priorTab[lang-1]); u++){
     SendMessage(combo,CB_ADDSTRING,0,(LPARAM)*u);
   }
   SendMessage(combo,CB_SETCURSEL,hk->priority,0);
   combo= GetDlgItem(hWnd,104);
   for(u=showTab[lang-1]; u<endA(showTab[lang-1]); u++){
     SendMessage(combo,CB_ADDSTRING,0,(LPARAM)*u);
   }
   SendMessage(combo,CB_SETCURSEL,hk->cmdShow,0);
   editWndProc = (WNDPROC) SetWindowLong(GetDlgItem(hWnd,103),
                GWL_WNDPROC, (LONG) hotKeyClassProc);
   initList();
  return TRUE;

  case WM_COMMAND:
   hk= &hotKeyA[(int) GetWindowLong(hWnd, GWL_USERDATA)];
   wP=LOWORD(wP);
   switch(wP){
    case 111:  //tlatko pro zadn exe souboru
     exeOfn.hwndOwner= hWnd;
     exeOfn.Flags= OFN_PATHMUSTEXIST|OFN_HIDEREADONLY;
     *exeBuf=0;
     if(GetOpenFileName(&exeOfn)){
       cpStr(hk->exe,exeBuf);
       SetDlgItemText(hWnd,101,hk->exe);
       SetFocus(GetDlgItem(hWnd,102));
     }
    break;
    case 115: //tlatko pro zadn parametru
     argOfn.hwndOwner= hWnd;
     argOfn.Flags= OFN_PATHMUSTEXIST|OFN_HIDEREADONLY;
     *exeBuf=0;
     if(GetOpenFileName(&argOfn)){
       cpStr(hk->args,exeBuf);
       SetDlgItemText(hWnd,102,hk->args);
       SetFocus(GetDlgItem(hWnd,102));
     }
    break;
    case 116:{ //tlatko pro zvolen pracovnho adrese
     BROWSEINFO bi;
     bi.hwndOwner= hWnd;
     bi.pidlRoot=0;
     bi.pszDisplayName= exeBuf;
     bi.lpszTitle= lng("Select working directory","Vyberte pracovn adres");
     bi.ulFlags=BIF_RETURNONLYFSDIRS;
     bi.lpfn=0;
     bi.iImage=0;
     ITEMIDLIST *iil;
     iil=SHBrowseForFolder(&bi);
     if(iil){
       if(SHGetPathFromIDList(iil,exeBuf)){
         cpStr(hk->dir,exeBuf);
         SetDlgItemText(hWnd,110,hk->dir);
         SetFocus(GetDlgItem(hWnd,112));
       }
       IMalloc *ma;
       SHGetMalloc(&ma);
       ma->Free(iil);
       ma->Release();
     }
    }
    break;

    case IDOK:{
     getText(hWnd,112,hk->note);
     getText(hWnd,110,hk->dir);
     hk->cmd= (int) SendMessage(GetDlgItem(hWnd,101),CB_GETCURSEL,0,0);
     if(hk->cmd!=CB_ERR){
       cpStr(hk->exe,"");
       hk->cmd= cmdOrder2[hk->cmd];
     }else{
       hk->cmd=-1;
       getText(hWnd,101,hk->exe);
       if(!SearchPath(0,hk->exe,".exe",sizeof(exeBuf),exeBuf,&filePart)){
         msg(lng("EXE file not found","EXE soubor nenalezen"));
         SetFocus(GetDlgItem(hWnd,101));
         break;
       }
       cpStr(hk->exe,exeBuf);
       if(!*hk->dir){
         *(filePart-1)=0;
         cpStr(hk->dir,exeBuf);
       }
       if(testDir(hk->dir)){
         msg(lng("Invalid working directory","Chybn pracovn adres"));
         SetFocus(GetDlgItem(hWnd,110));
         break;
       }
       if(!*hk->note){
         char *e= &filePart[strlen(filePart)-4];
         if(*e=='.') *e=0;
         cpStr(hk->note, filePart);
       }
     }
     getText(hWnd,102,hk->args);
     hk->scanCode= dlgKey.scanCode;
     hk->vkey= dlgKey.vkey;
     hk->modifiers=0;
     if(IsDlgButtonChecked(hWnd,106)==BST_CHECKED) hk->modifiers|=MOD_CONTROL;
     if(IsDlgButtonChecked(hWnd,107)==BST_CHECKED) hk->modifiers|=MOD_SHIFT;
     if(IsDlgButtonChecked(hWnd,108)==BST_CHECKED) hk->modifiers|=MOD_ALT;
     if(IsDlgButtonChecked(hWnd,109)==BST_CHECKED) hk->modifiers|=MOD_WIN;
     hk->priority= (int) SendMessage(GetDlgItem(hWnd,105),CB_GETCURSEL,0,0);
     hk->cmdShow= (int) SendMessage(GetDlgItem(hWnd,104),CB_GETCURSEL,0,0);
     hk->multInst= IsDlgButtonChecked(hWnd,113)==BST_CHECKED;
    }
    case IDCANCEL:
     EndDialog(hWnd, wP);
    break;
   }
  break;
  default:
   return FALSE;
 }
 return TRUE;
}
//---------------------------------------------------------------------------
void setCur(int item)
{
 SendMessage(listBox, LB_SETCURSEL, item, 0);
}

//editace klvesov zkratky
int editKey(int item)
{
 UnregisterHotKey(hWin, item);
 int result= (int) DialogBoxParam(inst, lng("HOTKEY_EN","HOTKEY_CZ"),
   hWin, (DLGPROC) hotkeyProc, (LPARAM)item);
 registerKeys();
 if(result==IDOK){
   SendMessage(listBox,LB_DELETESTRING,item,0);
   addItem(item);
   modif=true;
 }
 setCur(item);
 return result;
}

//smazn klvesov zkratky
void delKey(int item)
{
 unregisterKeys();
 HotKey *hk= &hotKeyA[item];
 delete[] hk->exe;
 delete[] hk->args;
 delete[] hk->note;
 delete[] hk->dir;
 --numKeys;
 memcpy(hotKeyA+item, hotKeyA+item+1, (numKeys-item)*sizeof(HotKey));
 registerKeys();
 SendMessage(listBox,LB_DELETESTRING,item,0);
 if(item==numKeys) item--;
 setCur(item);
 modif=true;
}

//pidn klvesov zkratky
void addKey()
{
 HotKey *hk= new HotKey[++numKeys];
 memcpy(hk, hotKeyA, sizeof(HotKey)*(numKeys-1));
 delete[] hotKeyA;
 hotKeyA= hk;
 hk= &hotKeyA[numKeys-1];
 memset(hk,0,sizeof(HotKey));
 hk->cmdShow= 0;
 hk->priority= 1;
 hk->cmd=-1;
 if(editKey(numKeys-1)==IDCANCEL){
   delKey(numKeys-1);
 }
}

void swapKey(int item)
{
 unregisterKeys();
 SendMessage(listBox,LB_DELETESTRING,item,0);
 HotKey k=hotKeyA[item];
 hotKeyA[item]=hotKeyA[item+1];
 item++;
 hotKeyA[item]=k;
 registerKeys();
 addItem(item);
 modif=true;
}

void hideMainWindow()
{
 //zapamatuj si polohu a velikost okna
 RECT rc;
 GetWindowRect(hWin,&rc);
 dlgX=rc.left;
 dlgY=rc.top;
 dlgW=rc.right-rc.left;
 dlgH=rc.bottom-rc.top;
 saveAtExit();
 ShowWindow(hWin,SW_HIDE);
}
//---------------------------------------------------------------------------
//dialogov procedura pro hlavn okno
BOOL CALLBACK MainWndProc(HWND hWnd, UINT mesg, WPARAM wP, LPARAM lP)
{
 POINT pt;
 HotKey *hk;
 static int tab;
 int t,cmd,item;

 switch (mesg) {
  case WM_INITDIALOG:
   listBox = GetDlgItem(hWnd,101);
   hFont=CreateFontIndirect(&font);
   SendMessage(listBox,WM_SETFONT,(WPARAM)hFont,(LPARAM)0);
  break;

  case WM_GETMINMAXINFO:
   ((MINMAXINFO FAR*) lP)->ptMinTrackSize.x = 360;
   ((MINMAXINFO FAR*) lP)->ptMinTrackSize.y = 280;
  break;

  case WM_COMMAND:
   cmd=LOWORD(wP);
   if(cmd>900 && cmd<=900+Nlang){
     setLang(cmd-900);
     break;
   }
   item= (int) SendMessage(listBox, LB_GETCURSEL,0,0);
   switch(cmd){
    case 100:
     MoveWindow(hWnd,dlgX,dlgY,dlgW,dlgH,TRUE);
     if(show==1 || cntStart<=1 && show!=0){
       ShowWindow(hWin,SW_SHOWDEFAULT);
     }
    break;
    case 101: //listBox
     if(HIWORD(wP)!=LBN_DBLCLK) return FALSE;
    case 102: //upravit
     if(item>=0 && item<numKeys){
       editKey(item);
     }
    break;
    case 103: //odstranit
     if(item>=0 && item<numKeys){
       delKey(item);
     }
    break;
    case 104: //nov
     addKey();
    break;
    case 105: //nahoru
     if(item>0 && item<numKeys){
       item--;
       swapKey(item);
       setCur(item);
     }
    break;
    case 106: //dolu
     if(item>=0 && item<numKeys-1){
       swapKey(item);
       setCur(item+1);
     }
    break;
    case 201: //otevt
     open();
    break;
    case 202: //uloit
     save();
    break;
    case 203: //ukonen programu
     hideMainWindow();
     DestroyWindow(hWnd);
    break;
    case 204: //schovn okna
     hideMainWindow();
    break;
    case 205: //odstranit konfiguraci z registru
     deleteini();
    break;
    case 206: //font
    {
     static CHOOSEFONT f;
     f.lStructSize=sizeof(CHOOSEFONT);
     f.hwndOwner=hWin;
     f.Flags=CF_SCREENFONTS|CF_INITTOLOGFONTSTRUCT|CF_SCRIPTSONLY;
     f.lpLogFont=&font;
     if(ChooseFont(&f)){
       DeleteObject(hFont);
       hFont=CreateFontIndirect(&font);
       SendMessage(listBox,WM_SETFONT,(WPARAM)hFont,
         (LPARAM)MAKELPARAM(TRUE,0));
     }
    }
    break;
    case 207: //nov soubor
     saveAtExit();
     unregisterKeys();
     numKeys=0;
     initList();
     *iniFile=0;
    break;

    case 300: //readme
    {
     char buf[256];
     getExeDir(buf,lng("Hotkeyp_EN.txt","Hotkeyp_CZ.txt"));
     if(ShellExecute(0,"open",buf,0,0,SW_SHOWNORMAL)==(HINSTANCE)ERROR_FILE_NOT_FOUND){
       msg(lng("File %s not found","Nenalezen soubor %s"),buf);
     }
    }
    break;

    case 301: //about
     DialogBox(inst, lng("ABOUT_EN","ABOUT_CZ"), hWnd, (DLGPROC) DlgProc);
    break;
   }
  break;

  case WM_SIZE:
   if(!lP) break;
   if(oldW){
     //pi zmn velikosti okna zm polohy vech ovldacch prvk
     int dw=LOWORD(lP)-oldW;
     int dh=HIWORD(lP)-oldH;
     moveX(hWnd,104,dw);
     moveX(hWnd,102,dw);
     moveX(hWnd,103,dw);
     moveX(hWnd,105,dw);
     moveX(hWnd,106,dw);
     moveW(hWnd,101,dw,dh);
   }
   oldW=LOWORD(lP);
   oldH=HIWORD(lP);
   t=25+LOWORD(lP)/10;
   if(t!=tab){
     tab=t;
     SendMessage(listBox, LB_SETTABSTOPS, 1, (LPARAM)&tab);
     InvalidateRect(listBox,0,TRUE);
   }
  break;

  case WM_HOTKEY:
   //byla stisknuta klvesov zkratka
   if(wP<unsigned(numKeys)){
    hk= &hotKeyA[(int)wP];
    if(hk->cmd>=0){
      command(hk->cmd,hk->args);
    }else{
      found=0;
      //zjisti, jestli u nen program sputn
      if(!hk->multInst){
        DWORD pid= findProcess(hk->exe);
        if(pid) EnumWindows((WNDENUMPROC)enumWin, (LPARAM)pid);
      }
      if(found){
        if(IsIconic(found)) ShowWindow(found,SW_RESTORE);
        SetForegroundWindow(found);
      }else{
        //pipojen parametr k nzvu programu
        char *s=0;
        if(*hk->args){
          s= new char[strlen(hk->exe)+strlen(hk->args)+2];
          strcpy(s,hk->exe);
          strcat(s," ");
          strcat(s,hk->args);
        }
        STARTUPINFO startupInfo;
        memset(&startupInfo,0,sizeof(STARTUPINFO));
        startupInfo.cb= sizeof(STARTUPINFO);
        startupInfo.dwFlags= STARTF_USESHOWWINDOW;
        startupInfo.wShowWindow= showCnst[hk->cmdShow];
        //sputn procesu
        PROCESS_INFORMATION pi;
        if(CreateProcess(hk->exe,s,0,0,0,priorCnst[hk->priority],
          0,hk->dir,&startupInfo,&pi)){
          CloseHandle(pi.hProcess);
          CloseHandle(pi.hThread);
        }else{
          msg(lng("Cannot start process %s","Nelze spustit %s"),hk->exe);
        }
        delete[] s;
      }
    }
    if(IsWindowVisible(hWin)) setCur((int)wP);
   }
  break;

  case WM_TIMER:
   switch(wP){
    case 1:
     ShowWindow(hWndVolume,SW_HIDE);
     KillTimer(hWin,wP);
    break;
    case 2:
     GetCursorPos(&pt);
     if(abs(mousePos.x-pt.x)>senz || abs(mousePos.y-pt.y)>senz){
       SendMessage(hWin,WM_SYSCOMMAND,SC_MONITORPOWER,-1);
       KillTimer(hWin,wP);
     }
    break;
    case 3:
     ShowWindow(hWndDiskFree,SW_HIDE);
     KillTimer(hWin,wP);
    break;
   }
  break;

  case WM_QUERYENDSESSION: //ukonen Windows
   saveAtExit();
  return FALSE;

  case WM_CLOSE: //zaven okna
   if(IsWindowVisible(hWnd)){
     hideMainWindow();
   }else{
     DestroyWindow(hWnd);
   }
  break;

  case WM_DESTROY:
   //konec programu
   hWin= listBox= 0;
   DeleteObject(hFont);
   unregisterKeys();
   PostQuitMessage(0);
  break;

  default:
   return FALSE;
 }
 return TRUE;
}
//---------------------------------------------------------------------------
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrev, LPSTR cmdLine, int cmdShow)
{
 MSG mesg;
 WNDCLASS wc;
 HKEY key;
 int i;
 size_t l;

 l=strlen(cmdLine);
 show=-1;
 if(cmdLine[l-1]=='0') show=0;
 if(cmdLine[l-1]=='1') show=1;

 //pokud u je program sputn, pak pouze zobraz a aktivuj jeho okno
 HWND w=FindWindow("PlasHotKey",0);
 if(w){
   if(show!=0){
     ShowWindow(w,cmdShow);
     SetForegroundWindow(w);
   }
   return 1;
 }
 for(i=0; i<sizeA(cmdOrder2); i++){
   cmdOrder[cmdOrder2[i]]=i;
 }
 inst=hInstance;
 pGetDiskFreeSpaceEx = (TdiskFreeFunc) GetProcAddress(GetModuleHandle("kernel32.dll"),
    "GetDiskFreeSpaceExA");
 font.lfHeight=16;
 font.lfWeight=FW_NORMAL;
 font.lfCharSet=DEFAULT_CHARSET;
 strcpy(font.lfFaceName,"Arial");
 readini();
 dlgX0=dlgX; dlgY0=dlgY;
 fontH=HIWORD(GetDialogBaseUnits());
 textY[0]=5;
 textY[1]=textY[0]+fontH+9;
 volH=textY[1]+fontH+5+2;
 aminmax(diskfreeW,100,500);

 wc.style=0;
 wc.lpfnWndProc=(WNDPROC)DefDlgProc;
 wc.cbClsExtra=0;
 wc.cbWndExtra=DLGWINDOWEXTRA;
 wc.hInstance=hInstance;
 wc.hIcon=LoadIcon(NULL,IDI_APPLICATION);
 wc.hCursor=LoadCursor(NULL, IDC_ARROW);
 wc.hbrBackground=(HBRUSH)COLOR_BTNFACE;
 wc.lpszMenuName=NULL;
 wc.lpszClassName="PlasHotKey";
 if(!hPrev && !RegisterClass(&wc)) return 2;

 wc.lpfnWndProc= (WNDPROC)VolumeWndProc;
 wc.cbWndExtra=0;
 wc.style= CS_SAVEBITS;
 wc.hbrBackground= brVolBk= CreateSolidBrush(colors[clVolBkgnd]);
 wc.lpszClassName="HotkeyVolume";
 if(!hPrev && !RegisterClass(&wc)) return 2;

 wc.lpfnWndProc= (WNDPROC)DiskFreeWndProc;
 wc.hbrBackground= brDskBk= CreateSolidBrush(colors[clDskBkgnd]);
 wc.lpszClassName="HotkeyDiskFree";
 if(!hPrev && !RegisterClass(&wc)) return 2;

 hWin = CreateDialog(hInstance,"WIN",0,(DLGPROC)MainWndProc);
 if(!hWin) return 3;
 PostMessage(hWin,WM_COMMAND,100,0);
 hWndVolume= CreateWindowEx(WS_EX_TOOLWINDOW,"HotkeyVolume","",
   WS_POPUP|WS_BORDER,0,0,
   volW,volH,hWin,0,hInstance,0);
 hWndDiskFree= CreateWindowEx(WS_EX_TOOLWINDOW,"HotkeyDiskFree","",
   WS_POPUP|WS_BORDER,0,0,
   diskfreeW,diskfreeH,hWin,0,hInstance,0);
 setLang(lang);
 rd(iniFile);
 if(RegOpenKey(HKEY_LOCAL_MACHINE, runkey, &key)==ERROR_SUCCESS ||
    RegOpenKey(HKEY_CURRENT_USER, runkey, &key)==ERROR_SUCCESS){
   i=GetModuleFileName(0,exeBuf,sizeof(exeBuf));
   if(i) RegSetValueEx(key, runName, 0,REG_SZ, (BYTE*)exeBuf, i+1);
   RegCloseKey(key);
 }
 cntStart++;
 haccel=LoadAccelerators(hInstance, MAKEINTRESOURCE(3));
 CoInitialize(0);
 while(GetMessage(&mesg, NULL, 0, 0)==TRUE)
  if(!TranslateAccelerator(hWin,haccel,&mesg)){
   if(!IsDialogMessage(hWin,&mesg)){
     TranslateMessage(&mesg);
     DispatchMessage(&mesg);
   }
  }
 CoUninitialize(); 
 return 0;
}
//---------------------------------------------------------------------------

